class Monster {
  boolean active;
  int x, y;
  int timer;
  
  Monster(int x, int y) {
    active = true;
    this.x = x;
    this.y = y;
    timer = 16;
  }
  
  void Update() {
    timer ++;
    if (timer > 11) {
      timer = 0;
      int dX = 0;
      int dY = 0;
      int playerDistanceX = playerX - x;
      int playerDistanceY = playerY - y;
      if ((abs(playerDistanceX) < 16) && (abs(playerDistanceY) < 16)) {
        if (playerDistanceX < 0) {
          dX = -1;
        }
        else if (playerDistanceX > 0) {
          dX = 1;
        }
        if (playerDistanceY < 0) {
          dY = -1;
        }
        else if (playerDistanceY > 0) {
          dY = 1;
        }
      }
      else {
        if (random(1) < 0.5) {
          dX = 1 - 2 * ((int) random(2));
        }
        else {
          dY = 1 - 2 * ((int) random(2));
        }
      }
      if (wall[x + dX][y + dY] == 0) {
        x += dX;
        y += dY;
      }
    }
    if ((x == playerX) && (y == playerY)) {
      dead = true;
    }
  }
  
  void Draw() {
    DrawPixel(x, y, 255, 64, 0);
  }
}
